Avro C#

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Avro.File.DataFileWriter< T > Class Template Reference

Stores in a file a sequence of data conforming to a schema. The schema is stored in the file with the data. Each datum in a file is of the same schema. Data is written with a DatumWriter<T>. Data is grouped into blocks. A synchronization marker is written between blocks, so that files may be split. Blocks may be compressed. Extensible metadata is stored at the end of the file. Files may be appended to. More...

Inheritance diagram for Avro.File.DataFileWriter< T >:

## Public Member Functions
bool | IsReservedMeta (string key)
| Returns true if parameter is a reserved Avro metadata value.
void | SetMeta (string key, byte[] value)
| Set metadata pair.
void | SetMeta (string key, long value)
| Set metadata pair (long value).
void | SetMeta (string key, string value)
| Set metadata pair (string value).
void | SetSyncInterval (int syncInterval)
| Set the synchronization interval for this file or stream, in bytes. Valid values range from 32 to 2^30. Suggested values are between 2K and 2M.
void | Append (T datum)
| Append datum to a file or stream.
void | Flush ()
| Flush out any buffered data.
long | Sync ()
| Forces the end of the current block, emitting a synchronization marker.
void | Close ()
| Closes the file or stream.
void | Dispose ()

## Static Public Member Functions
static IFileWriter< T > | OpenWriter (DatumWriter< T > writer, string path)
| Open a new writer instance to write to a file path, using a Null codec More...
static IFileWriter< T > | OpenWriter (DatumWriter< T > writer, Stream outStream)
| Open a new writer instance to write to an output stream, using a Null codec More...
static IFileWriter< T > | OpenWriter (DatumWriter< T > writer, Stream outStream, bool leaveOpen)
| Open a new writer instance to write to an output stream, using a Null codec More...
static IFileWriter< T > | OpenWriter (DatumWriter< T > writer, string path, Codec codec)
| Open a new writer instance to write to a file path with a specified codec More...
static IFileWriter< T > | OpenWriter (DatumWriter< T > writer, Stream outStream, Codec codec)
| Open a new writer instance to write to an output stream with a specified codec More...
static IFileWriter< T > | OpenWriter (DatumWriter< T > writer, Stream outStream, Codec codec, bool leaveOpen)
| Open a new writer instance to write to an output stream with a specified codec More...
static IFileWriter< T > | OpenAppendWriter (DatumWriter< T > writer, string path)
| Open a new writer instance to append to a file path. More...
static IFileWriter< T > | OpenAppendWriter (DatumWriter< T > writer, Stream inStream, Stream outStream)
| Open a new writer instance to append to an output stream. Both in and out streams must point to the same file. More...

## Protected Member Functions
virtual void | Dispose (bool disposing)
| Releases resources associated with this DataFileWriter<T>. More...

## Detailed Description

Stores in a file a sequence of data conforming to a schema. The schema is stored in the file with the data. Each datum in a file is of the same schema. Data is written with a DatumWriter<T>. Data is grouped into blocks. A synchronization marker is written between blocks, so that files may be split. Blocks may be compressed. Extensible metadata is stored at the end of the file. Files may be appended to.

Template Parameters

  T | Type of datum to write to the file.

See also
  IFileWriter<T>

## Member Function Documentation

## ◆ Dispose()

virtual void Avro.File.DataFileWriter< T >.Dispose | ( | bool | disposing | ) |
| inline protected virtual

Releases resources associated with this DataFileWriter<T>.

Parameters

  disposing | True if called from Dispose(); false otherwise.

## ◆ OpenAppendWriter() [1/2]

static IFileWriter<T> Avro.File.DataFileWriter< T >.OpenAppendWriter | ( | DatumWriter< T > | writer,
|  | Stream | inStream,
|  | Stream | outStream
| ) |  |
| inline static

Open a new writer instance to append to an output stream. Both in and out streams must point to the same file.

Parameters

  writer | Datum writer to use.
  inStream | reading the existing file.
  outStream | stream to write to, positioned at the end of the existing file.

Returns
  A new file writer.

Exceptions

  AvroRuntimeException | {nameof(inStream)} must have Read access or {nameof(outStream)} must have Write access

## ◆ OpenAppendWriter() [2/2]

static IFileWriter<T> Avro.File.DataFileWriter< T >.OpenAppendWriter | ( | DatumWriter< T > | writer,
|  | string | path
| ) |  |
| inline static

Open a new writer instance to append to a file path.

Parameters

  writer | Datum writer to use.
  path | Path to the file.

Returns
  A new file writer.

## ◆ OpenWriter() [1/6]

static IFileWriter<T> Avro.File.DataFileWriter< T >.OpenWriter | ( | DatumWriter< T > | writer,
|  | Stream | outStream
| ) |  |
| inline static

Open a new writer instance to write to an output stream, using a Null codec

Parameters

  writer | Datum writer to use.
  outStream | Stream to write to.

Returns
  A new file writer.

## ◆ OpenWriter() [2/6]

static IFileWriter<T> Avro.File.DataFileWriter< T >.OpenWriter | ( | DatumWriter< T > | writer,
|  | Stream | outStream,
|  | bool | leaveOpen
| ) |  |
| inline static

Open a new writer instance to write to an output stream, using a Null codec

Parameters

  writer | Datum writer to use.
  outStream | Stream to write to.
  leaveOpen | Leave the stream open after disposing the object

Returns
  A new file writer.

## ◆ OpenWriter() [3/6]

static IFileWriter<T> Avro.File.DataFileWriter< T >.OpenWriter | ( | DatumWriter< T > | writer,
|  | Stream | outStream,
|  | Codec | codec
| ) |  |
| inline static

Open a new writer instance to write to an output stream with a specified codec

Parameters

  writer | Datum writer to use.
  outStream | Stream to write to.
  codec | Codec to use when writing.

Returns
  A new file writer.

## ◆ OpenWriter() [4/6]

static IFileWriter<T> Avro.File.DataFileWriter< T >.OpenWriter | ( | DatumWriter< T > | writer,
|  | Stream | outStream,
|  | Codec | codec,
|  | bool | leaveOpen
| ) |  |
| inline static

Open a new writer instance to write to an output stream with a specified codec

Parameters

  writer | Datum writer to use.
  outStream | Stream to write to.
  codec | Codec to use when writing.
  leaveOpen | Leave the stream open after disposing the object

Returns
  A new file writer.

## ◆ OpenWriter() [5/6]

static IFileWriter<T> Avro.File.DataFileWriter< T >.OpenWriter | ( | DatumWriter< T > | writer,
|  | string | path
| ) |  |
| inline static

Open a new writer instance to write to a file path, using a Null codec

Parameters

  writer | Datum writer to use.
  path | Path to the file.

Returns
  A new file writer.

## ◆ OpenWriter() [6/6]

static IFileWriter<T> Avro.File.DataFileWriter< T >.OpenWriter | ( | DatumWriter< T > | writer,
|  | string | path,
|  | Codec | codec
| ) |  |
| inline static

Open a new writer instance to write to a file path with a specified codec

Parameters

  writer | Datum writer to use.
  path | Path to the file.
  codec | Codec to use when writing.

Returns
  A new file writer.

The documentation for this class was generated from the following file:

- src/apache/main/File/DataFileWriter.cs